#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <X11/Xlib.h>

/*
 * Einfaches Programm zur Ausgabe eines schrggestellten X-Strings 
 * Schrift, Gre und Winkel sind fest eingestellt.
 * Das Fenster wird geschlossen, wenn der Benutzer
 * eine Taste drckt, whrend es den Fokus hat
 */


main(int argc, char *argv[]) {
  Display *display;
  char *ptr;
  Window win;
  GC gc;
  XSetWindowAttributes  xswa;
  int screen_num, depth;
  int win_width, win_height;
  Visual*   visual;
  Colormap  colormap;
  Font      font;
  char *text = "Test";
  XTextItem textitem;

  if (argc > 1)
    text = argv[1];
  
  display = XOpenDisplay(NULL);
  
  screen_num = DefaultScreen  ( display );
  colormap   = DefaultColormap( display, screen_num );
  depth      = DefaultDepth   ( display, screen_num );
  visual     = DefaultVisual  ( display, screen_num );

  xswa.border_pixel     = BlackPixel( display, screen_num );
  xswa.background_pixel = WhitePixel( display, screen_num );
  
  xswa.event_mask = KeyPressMask | ExposureMask;
  
  win_width =  400;
  win_height = 200;

  win = XCreateWindow ( display,
		       RootWindow( display, screen_num ),
		       0,
		       0,
		       win_width,
		       win_height,
		       10,
		       depth,
		       InputOutput, 
		       visual,
		       CWBackPixel | CWBorderPixel | CWEventMask,
		       &xswa );
  
  XMapWindow( display, win );
  
  font = XLoadFont(display,
		   "-urw-helvetica-bold-r-normal--"
		   "0-[30 15 ~15 30]-0-0-p-0-iso8859-1");

  gc = XCreateGC( display, RootWindow( display, screen_num ),
		       0L, NULL );
  XSetForeground( display, gc, BlackPixel( display, screen_num ) );
  XSetBackground( display, gc, WhitePixel( display, screen_num ) );
  XSetFont(display, gc, font);
  textitem.chars = text;
  textitem.nchars = strlen(text);
  textitem.delta = 0;
  textitem.font = font;

  while (1) {
    XEvent event;
    XNextEvent(display, &event);
    switch (event.type) {
      case Expose:
	XDrawString(display, win, gc, 10,(win_height - 30) / 2,
		    text, strlen(text));
	break;
      case KeyPress:
	exit(0);
    }
  }/* while 1 */
}
